// Generated by CoffeeScript 1.7.1
var cdl, exec, options, sys, _;

exec = require('child_process').exec;

sys = require('sys');

_ = require('underscore');

cdl = require('nomnom').script("backup").options({
  domain: {
    position: 0,
    help: "The Meteor domain to backup",
    required: true
  },
  collections: {
    position: 1,
    help: "Which collections to include",
    list: true,
    required: true
  },
  dir: {
    abbr: 'd',
    full: 'dir',
    metavar: 'PATH',
    help: "The directory where JSON files will be saved (please end with '/', defaults to current dir)",
    "default": './'
  },
  prefix: {
    full: "prefix",
    help: "Prefix text to prepend to JSON filename (e.g. a date)",
    "default": ""
  },
  postfix: {
    full: "postfix",
    help: "Postfix text to append to JSON filename (e.g. a date)",
    "default": ""
  }
});

options = cdl.parse();

exec("meteor mongo " + options.domain + " --url", function(error, stdout, stderr) {
  var db, dir, host, password, port, protocol, url, username;
  if (stderr) {
    console.log("Error getting domain URL:");
    console.log(stderr);
  }
  if (stdout) {
    url = stdout.split(/:\/\/|:|@|\/|\n|\r/);
    protocol = url[0];
    username = url[1];
    password = url[2];
    host = url[3];
    port = url[4];
    db = url[5];
    dir = options.dir;
    if (dir.charAt(dir.length - 1) !== '/') {
      dir = dir + '/';
    }
    return _.each(options.collections, function(collection) {
      var exportCmd;
      exportCmd = "mongoexport -h " + host + " --port " + port + " -u " + username + " -p " + password + " -d " + db + " -c " + collection + " -o " + dir + options.prefix + collection + options.postfix + ".json";
      console.log(exportCmd);
      return exec(exportCmd, function(err, sout, serr) {
        if (sout) {
          console.log(sout);
        }
        if (serr) {
          console.log("An error occurred during export:");
          return console.log(serr);
        }
      });
    });
  }
});
