// Generated by CoffeeScript 1.7.1
var cdl, flatten, fs, options, _;

fs = require('fs');

_ = require('underscore');

cdl = require('nomnom').script("json2csv").options({
  inputFile: {
    position: 0,
    help: "The JSON file to convert",
    required: true
  },
  outputFile: {
    position: 1,
    help: "The name of the CSV output file (optional)",
    required: false
  }
});

options = cdl.parse();

flatten = function(root, obj) {
  var result;
  if (root == null) {
    root = "";
  }
  result = {};
  _.each(_.keys(obj), function(key) {
    var value;
    value = obj[key];
    if (_.isArray(value)) {
      return _.each(value, function(element, index) {
        var indexed_key;
        indexed_key = key + "_" + index;
        if (_.isObject(element)) {
          return _.extend(result, flatten(indexed_key, element));
        } else {
          return result[indexed_key] = element;
        }
      });
    } else {
      if (_.isObject(value)) {
        return _.extend(result, flatten(key, value));
      } else {
        if (root !== "") {
          key = root + "_" + key;
        }
        return result[key] = value;
      }
    }
  });
  return result;
};

fs.readFile(options.inputFile, {
  encoding: "UTF-8"
}, function(err, data) {
  var flat, lines, parsed, unique_keys, write;
  if (err) {
    console.log(err);
  }
  if (data) {
    parsed = [];
    lines = data.split(/[\n\r]/);
    _.each(lines, function(line) {
      var input;
      input = line.trim();
      if (input !== "") {
        return parsed.push(JSON.parse(input));
      }
    });
    flat = [];
    _.each(parsed, function(obj) {
      return flat.push(flatten("", obj));
    });
    unique_keys = [];
    _.each(flat, function(obj) {
      return _.each(_.keys(obj), function(key) {
        if (!_.contains(unique_keys, key)) {
          return unique_keys.push(key);
        }
      });
    });
    write = console.log;
    if (options.outputFile) {
      write = function(text) {
        return fs.appendFile(options.outputFile, text + '\n', function(err) {
          throw err;
        });
      };
    }
    write(_.map(unique_keys, function(k) {
      return "\"" + k + "\"";
    }).join(","));
    return _.each(flat, function(obj) {
      var csv, error, padded;
      try {
        csv = [];
        _.each(unique_keys, function(key) {
          return csv.push(obj[key] || "");
        });
        padded = _.map(csv, function(v) {
          if (_.isString(v)) {
            v = v.replace(/\"/g, "\"\"");
          }
          return "\"" + v + "\"";
        });
        return write(padded.join(","));
      } catch (_error) {
        error = _error;
        console.log("Error processing: ", obj);
        throw error;
      }
    });
  }
});
